Load "ps2-starter.v".
Open Scope string_scope.

(* This file is intended to help you get used to the way big and small step 
 * are formulated in Coq. It is not part of your homework and you will not 
 * be submitting it. *)

(* something simple first *)

Goal bigStep (Abs "x" (Var "x")) (Normal (Abs "x" (Var "x"))).
eapply BigAbs.
Qed.


Goal contextStepStar (Abs "x" (Var "x")) (Abs "x" (Var "x")).
eapply StarRefl.
Qed.

Goal contextStepStar (App
                       (Abs "a" (Var "a"))
                       (Abs "b" (Var "b"))) 
                     (Abs "b" (Var "b")).
eapply StarStep.
apply (ContextBeta Hole).
apply ValueAbs.
simpl.
eapply StarRefl.
Qed.

(* Here we perform the big and small step evaluation manually on a single lambda expression, 
 * We see that they produce the same results. In homework you will be showing it in general *)

(* The big step evaluation of an expression *)
Goal bigStep (App
               (App 
                 (Abs "f" (Abs "x" (App (Var "f")(Var "x"))))
                 (Abs "a" (Var "a")))
               (Abs "b" (Var "b"))) 
             (Normal (Abs "b" (Var "b"))).
Admitted.

(* The small step evaluation of an expression *)
(* Hints: 
 * use transitivity of a star step to break a single star step into multiple smaller ones
 * use the lemmas in ps2-starter.v to push star steps into sub-expressions (stepApp1 etc.) *)
Goal contextStepStar (App
                       (App 
                         (Abs "f" (Abs "x" (App (Var "f")(Var "x"))))
                         (Abs "a" (Var "a")))
                       (Abs "b" (Var "b"))) 
                     (Abs "b" (Var "b")).
Admitted.

(* There are more forms lambda expressions, in particular, one with the
 * catch / throw constructs. It may be helpful to make a few examples by hand and convince 
 * yourself that the big/small step evaluation does indeed produce the same result *)
